"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CardImageUploadSortable = void 0;
var react_1 = __importStar(require("react"));
var react_animated_number_1 = __importDefault(require("react-animated-number"));
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var classnames_1 = __importDefault(require("classnames"));
var S = __importStar(require("./CardImageUploadSortable.style"));
exports.CardImageUploadSortable = react_1.default.memo(function CardImageUploadSortable(_a) {
    var dragging = _a.dragging, dragOverlay = _a.dragOverlay, value = _a.value, index = _a.index, onRetry = _a.onRetry, listeners = _a.listeners, disabled = _a.disabled, onRotate = _a.onRotate, onRemove = _a.onRemove, rest = __rest(_a, ["dragging", "dragOverlay", "value", "index", "onRetry", "listeners", "disabled", "onRotate", "onRemove"]);
    var formatValue = react_1.useCallback(function (n) { return n.toFixed(0); }, []);
    function rotateImage(a) {
        var _a;
        var angle = (_a = value.rotate) !== null && _a !== void 0 ? _a : 0;
        angle += a;
        if (onRotate)
            onRotate(angle, value);
    }
    return (react_1.default.createElement(S.ImageContainer, __assign({ disabled: disabled }, rest),
        react_1.default.createElement("div", __assign({ className: classnames_1.default('item', dragging && 'dragging', dragOverlay && 'dragOverlay') }, listeners),
            react_1.default.createElement("div", { className: "cover", style: { backgroundImage: "url(" + value.image + ")", transform: "rotate(" + value.rotate + "deg)" } })),
        !dragging && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: "icon-close", "data-testid": "remove", onClick: function () { return onRemove && onRemove(value); } },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes })),
            react_1.default.createElement("div", { className: "icon-rotate-left", "data-testid": "rotate-left", onClick: function () { return rotateImage(-90); } },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faUndo })),
            react_1.default.createElement("div", { className: "icon-rotate-right", "data-testid": "rotate-right", onClick: function () { return rotateImage(90); } },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faRedo })))),
        value.loading && !value.error && (react_1.default.createElement("div", { className: "loading" },
            react_1.default.createElement("div", { className: "progress-loading" },
                react_1.default.createElement("div", { className: "value" },
                    react_1.default.createElement(react_animated_number_1.default, { value: value.percentage, duration: 200, formatValue: formatValue }),
                    "%"),
                react_1.default.createElement("div", { className: "load-bar" },
                    react_1.default.createElement("div", { className: "load-bar-finish", style: {
                            width: value.percentage + "%",
                        } }))))),
        value.error && (react_1.default.createElement("div", { className: "error-container" },
            react_1.default.createElement("div", { className: "error" },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faExclamationCircle }),
                "\u00A0 Erro ao fazer upload",
                react_1.default.createElement("button", { onClick: function () { return onRetry && onRetry(value); }, type: "button" }, "Tentar novamente"))))));
});
//# sourceMappingURL=CardImageUploadSortable.js.map