import React, { InputHTMLAttributes } from 'react';
import { IPropsMask } from '../MaskText';
export interface ICustomInputProps {
    inputProps?: any;
    title?: any;
    prefix?: string | JSX.Element;
    suffix?: string | JSX.Element;
    error?: string;
    focus?: boolean;
    loading?: boolean;
    password?: boolean;
    textCenter?: boolean;
    hidePassword?: boolean;
    setHidePassword?: (v: boolean) => void;
}
export interface IInputProps extends Omit<InputHTMLAttributes<HTMLInputElement>, 'prefix' | 'onInput'> {
    name?: any;
    title?: any;
    prefix?: string | JSX.Element;
    suffix?: string | JSX.Element;
    textRight?: boolean;
    textCenter?: boolean;
    password?: boolean;
    loading?: boolean;
    type?: string;
    mask?: IPropsMask['mask'];
    withoutDotNumber?: boolean;
    decimals?: number;
    error?: string;
    value?: string | number;
    onInput?: (text: any) => any;
    onBlur?: (text: any) => any;
    onEnter?: (text: any) => any;
    defaultValue?: string;
    CustomComponent?: React.FunctionComponent<ICustomInputProps>;
    as?: React.FunctionComponent<any>;
}
//# sourceMappingURL=InputCore.interface.d.ts.map