"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
var react_1 = __importStar(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var useDidUpdateEffect_1 = require("@devesharp/react-hooks/dist/useDidUpdateEffect");
var useEventListener_1 = require("@devesharp/react-hooks/dist/useEventListener");
var Modal_style_1 = require("./Modal.style");
exports.Modal = function Modal(props) {
    var children = props.children, show = props.show, onRequestClose = props.onRequestClose, _a = props.animation, animation = _a === void 0 ? 'fade' : _a, _b = props.transparent, transparent = _b === void 0 ? false : _b, _c = props.disableAnimation, disableAnimation = _c === void 0 ? false : _c, rest = __rest(props, ["children", "show", "onRequestClose", "animation", "transparent", "disableAnimation"]);
    var _d = react_1.useState(show), internalShow = _d[0], setInternalShow = _d[1];
    var _e = react_1.useState(false), closing = _e[0], setClosing = _e[1];
    var timeoutRef = react_1.useRef();
    useDidUpdateEffect_1.useDidUpdateEffect(function () {
        if (!show) {
            setClosing(true);
            if (disableAnimation) {
                setInternalShow(false);
                if (onRequestClose)
                    onRequestClose();
            }
            else {
                if (timeoutRef.current)
                    clearTimeout(timeoutRef.current);
                timeoutRef.current = setTimeout(function () {
                    setInternalShow(false);
                    if (onRequestClose)
                        onRequestClose();
                }, 300);
            }
        }
        else {
            setClosing(false);
            setInternalShow(true);
        }
    }, [show]);
    react_1.useEffect(function () { return function () { return timeoutRef.current && clearTimeout(timeoutRef.current); }; }, []);
    useEventListener_1.useEventListener('keydown.esc', function () {
        if (onRequestClose)
            onRequestClose();
    });
    return react_dom_1.default.createPortal(react_1.default.createElement(react_1.default.Fragment, null, internalShow && (react_1.default.createElement(Modal_style_1.ModalContainerStyle, __assign({ animation: animation, disableAnimation: disableAnimation }, rest),
        react_1.default.createElement("div", { className: "ds-modal-container " + (closing && ' closing') },
            !transparent && react_1.default.createElement("div", { className: "bg-background", onClick: function () { return onRequestClose && onRequestClose(); } }),
            react_1.default.createElement(react_1.default.Fragment, null, children))))), document.querySelector('body'));
};
exports.Modal.Body = function ModalBody(props) {
    var children = props.children, show = props.show, name = props.name, onRequestClose = props.onRequestClose, rest = __rest(props, ["children", "show", "name", "onRequestClose"]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Modal_style_1.ModalStyle, __assign({}, rest), children)));
};
//# sourceMappingURL=Modal.js.map