"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NavActions = void 0;
var react_1 = __importDefault(require("react"));
var free_regular_svg_icons_1 = require("@fortawesome/free-regular-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var styled_components_1 = require("styled-components");
var theme_interface_1 = require("../../types/theme.interface");
var NavActions_style_1 = __importDefault(require("./NavActions.style"));
var NavActions = function (_a) {
    var _b;
    var options = _a.options, selected = _a.selected, onUnselectAll = _a.onUnselectAll, backgroundColor = _a.backgroundColor, textColorProps = _a.textColor;
    var theme = styled_components_1.useTheme();
    var _c = (theme !== null && theme !== void 0 ? theme : {}).navActions, navActions = _c === void 0 ? {} : _c;
    var textColor = navActions.textColor;
    var color = (_b = textColorProps !== null && textColorProps !== void 0 ? textColorProps : textColor) !== null && _b !== void 0 ? _b : theme_interface_1.ThemeDefault.primaryTextInside;
    return (react_1.default.createElement(NavActions_style_1.default, { color: color, background: backgroundColor },
        react_1.default.createElement("div", { className: "nav-actions", "data-testid": "nav-actions" },
            react_1.default.createElement("table", null,
                react_1.default.createElement("tbody", null,
                    react_1.default.createElement("tr", null,
                        react_1.default.createElement("td", { className: "deselect", onClick: onUnselectAll, "data-testid": "deselect" },
                            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_regular_svg_icons_1.faMinusSquare })),
                        react_1.default.createElement("td", { className: "count-items", "data-testid": "items-count" }, selected),
                        react_1.default.createElement("td", { className: "actions" }, options &&
                            options.map(function (i) { return (react_1.default.createElement("div", { className: "header-icon", key: i.id, "data-testid": "action-" + i.id, onClick: i.onPress }, i.item)); }))))))));
};
exports.NavActions = NavActions;
//# sourceMappingURL=NavActions.js.map