import React, { useState } from 'react';
import { maskValue } from './mask.utils';

export interface IPropsMask {
   value: string | number; // valor
   mask?: 'CEP' | 'CNPJ' | 'CPF' | 'CNPJ/CPF' | 'RG' | 'phone' | 'number' | 'no-spaces' | 'date'; // máscara do input
   withoutDotNumber?: boolean; // quando mask for 'number', não mostra pontos nas casas de 1000
   decimals?: number; // quando mask for 'number', quantidade de decimais
}

export const MaskText: React.FunctionComponent<IPropsMask> = (props: IPropsMask) => {
   const newVal = maskValue(props.value, props.mask, props as any);

   return <>{newVal}</>;
};
